function ResultsFormLoaded()
    local frame = GetFrameByName(nil, "editframe");
    local elementCollection = frame.Document.All:GetElementsByName("jorders0");

    if elementCollection.Count == 0 then
        DisplayError("Cannot fill without a valid search result");
        return;
    end
    
	for i = 0, elementCollection.Count - 1, 1 do
		element = GetElementByCollectionIndex(elementCollection, i)
		if element.GetAttribute(element, "name") == "Routing" then			
            ClickObjectByReference(element.Parent)
			HandleManualPageChange()
			return
		end
	end    


    local Object = luanet.import_type('System.Object');
    local invokeArgs;
       
    --Select first result
    invokeArgs = Object[1];
    invokeArgs[0] = 1;
    
    frame.Document:InvokeScript("selectAll", invokeArgs);
    
    --Routing
	local elementCollection = frame.Document:GetElementsByTagName("img");
	local element = nil;
    
	for i = 0, elementCollection.Count - 1, 1 do
		element = GetElementByCollectionIndex(elementCollection, i)
		if element.GetAttribute(element, "title") == "Routing" then			
            ClickObjectByReference(element.Parent)
			HandleManualPageChange()
			return
		end
	end    
end

function OrderFormLoaded()
    local frame = GetFrameByName(nil, "editframe");
    
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Article").Value
	if (currentValue ~= nil) then
		SetFormValue("", "PART_TITLE", currentValue)
	end
	
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Author").Value
	if (currentValue ~= nil) then
		SetFormValue("", "PART_AUTHOR", currentValue)
	end
	
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Volume").Value
	if (currentValue ~= nil) then
		SetFormValue("", "VOLUME", currentValue)
	end
	
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Issue").Value
	if (currentValue ~= nil) then
		SetFormValue("", "ISSUE", currentValue)
	end
	
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Pages").Value
	if (currentValue ~= nil) then
		SetFormValue("", "PAGES", currentValue)
	end
	
	local currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PubYear").Value
	if (currentValue ~= nil) then
		SetFormValue("", "PUB_YEAR", currentValue)
	end
		
    --Next
	local elementCollection = frame.Document:GetElementsByTagName("img");
	local element = nil;
    
	for i = 0, elementCollection.Count - 1, 1 do
		element = GetElementByCollectionIndex(elementCollection, i)
		if element.GetAttribute(element, "title") == "Next" then
            ClickObjectByReference(element.Parent)
			HandleManualPageChange()
			return
		end
	end
end

local clock = os.clock

function Sleep(n)
    local t0 = clock()
    while clock() - t0 <= n do end
end

function RouteFormLoaded()    
	-- We will need this later, so I'm going to grab it now so that it will already be cached when I do the SetFormValue calls.
	local routeForm = GetForm(GetFrameByName(nil, "editframe"), "theform")
	local editFrame = GetFrameByName(nil, "editframe");
    
    local currentValue;
    
    currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "RequestForm").Value        
	if (currentValue ~= nil) then
        local requestFormElements = routeForm.All:GetElementsByName("REQUEST_FORM");
        
        for i = 0, requestFormElements.Count - 1, 1 do
            input = GetElementByCollectionIndex(requestFormElements, i)
            
            if (input.GetAttribute(input, "value") == currentValue) then
                ClickObjectByReference(input);               
                break;
            end
        end        
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "CopyrightCompliance").Value
	if currentValue ~= nil then
		SetFormValue("theform", "COPYRIGHT_COMPLIANCE", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ServiceLevel").Value
	if currentValue ~= nil then
		SetFormValue("theform", "SERVICE_LEVEL",currentValue )
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "AuthorizedBy").Value
	if currentValue ~= nil then
		SetFormValue("theform", "REQUEST_AUTHORIZED_BY", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ReferralReason").Value
	if currentValue ~= nil then
		SetFormValue("theform", "REFERRAL_REASON", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "MaxCost").Value
	if currentValue ~= nil then
		SetFormValue("theform", "MAX_COST", currentValue)
	end
	
    currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PatronName").Value
	if currentValue ~= nil then
        SetFormValue("theform", "PNAME", currentValue)
    end
	
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NeedByDate").Value
	if currentValue ~= nil then
		SetFormValue("theform", "NEED_BY_DATE", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NetworkShippingOption").Value
	if currentValue ~= nil then        
		SetFormValue("theform", "DELIVERY_NETWORK", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NLMShippingOption").Value
	if currentValue ~= nil then
        SetFormValue("theform", "DELIVERY_NLM", currentValue)
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PrefixLIBID").Value
	if currentValue ~= nil then
		SetFormValue("theform", "PREFIX_LIBID", currentValue)
	end
	
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ShipToName").Value
	if currentValue ~= nil then
		SetFormValue("theform", "INST", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Department").Value
	if currentValue ~= nil then
		SetFormValue("theform", "DEPT", currentValue)
	end
    
	StartPageWatcher(1000,0);
end

function Finished()
	StopPageWatcher();
    
	local importFrame = nil
	local importRegex = nil
	local resultFormPage = false
	if GetForm(nil, "resultForm") ~= nil then
		importFrame = GetFrameByName(nil, "editframe")
		resultFormPage = true
	elseif GetForm(nil, "backForm") ~= nil then
		importFrame = GetFrameByName(nil, "mainframe")
		importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Part Author:(?<Authors>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}Citation:.*?(?<Year>\d{0,4}).*?;((?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n)){0,1})]=]
	else
		importFrame = GetFrameByName(nil, "editframe")
		importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
	end	

	if (importFrame.Document.Body ~= nil) then
		local counter = 0
		while (importFrame.Document.Body.InnerText == "Working on requests, please wait..." and counter < 50) do
			Sleep(100)
			counter = counter + 1
		end
		
		if (counter == 50) then
			return
		end

		if resultFormPage == true then
			if string.find(importFrame.Document.Body.InnerText, "Result:", 0, true) ~= nil then
				importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Title:(?<Title>.*?\n)){0,1}(Author:(?<JournalAuthor>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}(Part Author:(?<Authors>.*?\n)){0,1}Citation:(?<Year>\d{0,4});(?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n))]=]
			elseif string.find(importFrame.Document.Body.InnerText, "NLM UNIQUE ID:", 0, true) ~= nil then
				importRegex = [=[(?mxns)
								 .*?(?<ID>\d*?)\swas\srouted\sto
								 .*?\((?<Lender>.+?)\).*?\r\n
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^Title:\s(?<Title>.+?)\r\n)?
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^(Part\s)?Author:\s(?<Authors>.+?)\r\n)?							  
							  ]=]
			else
				importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
			end	
		end
		DoDataImport(importFrame.Document.Body.InnerText, importRegex)
		RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	end
end

function IsFinishedPage(browser)
	if GetForm(nil, "resultForm") ~= nil then
		return true
	elseif GetForm(nil, "backForm") ~= nil then
		return true
	else
		window = GetFrameByName(nil, "editframe")
		
		if window == nil then
			return false
		end
		
		local elementCollection = window.Document.GetElementsByTagName(window.Document, "img")
	
		for i = 0, elementCollection.Count, 1 do	
			element = GetElementByCollectionIndex(elementCollection, i)
			if (element ~= nil and element.GetAttribute(element, "title") == "Full Display") then
				return true
			end
		end
		
		return false				
	end
end

function InitializeScript()
    local browser = GetBrowser();
	browser.ScriptErrorsSuppressed = true;
    
	RegisterPageHandler("formExists", "theform", "RouteFormLoaded", false)
	RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	
	FieldTranslator = GetFieldTranslator()    
end

if GetForm(null, "myform") ~= nil then
	InitializeScript()
	
	ResultsFormLoaded()
else
    --Check for manual citation entry form
    window = GetFrameByName(nil, "editframe")
		
    if window == nil then
        return false
    end

    local foundOrderForm = false;
    local elementCollection = window.Document.GetElementsByTagName(window.Document, "h3")

    for i = 0, elementCollection.Count, 1 do	
        element = GetElementByCollectionIndex(elementCollection, i)
        if (element ~= nil and element.InnerText == "Citation Input") then
            InitializeScript()
            OrderFormLoaded()
            
            foundOrderForm = true;
            break;
        end
    end
    
    if foundOrderForm ~= true then
        DisplayError("This process is meant to be initiated from the Search Results or Order Form pages.  Please return to an appropriate page and try again.")
    end
end