function LoginLoaded()
    local browser = GetBrowser();
	browser.ScriptErrorsSuppressed = true;
    
	SetFormValueById("user", "username", FieldTranslator.GetTranslationResults(FieldTranslator, "UserID").Value)
	SetFormValueById("user", "password", FieldTranslator.GetTranslationResults(FieldTranslator, "Password").Value)
	SubmitForm("user")
end

function OnLoggedIn()
	local navRequestsElement = GetElementInFrame("doclinemenu", "navRequests")
	if navRequestsElement ~= nil then
		ClickObjectByReference(GetParentElement(navRequestsElement))
		NavRequestsClicked()
	end
end

function NavRequestsClicked()
	local borrowingElement = FindBorrowLink()
	if borrowingElement ~= nil then
		ClickObjectByReference(borrowingElement)
	end
end

function SearchFormLoaded()
    local element = FindPMIDInput()
    
    if (element ~= nil) then
        element.SetAttribute(element, "value", FieldTranslator.GetTranslationResults(FieldTranslator, "PubMedSearchID").Value)
    end
	
    local doclineFrame = GetFrameByName(nil, "mainframe")
	if doclineFrame == nil then
		return
	end	
    
    doclineFrame.Document:InvokeScript("submitFormPMID", nil);
end

function FindPMIDInput()
	local doclineFrame = GetFrameByName(nil, "mainframe")
	if doclineFrame == nil then
        return nil
	end	
    
    local inputCollection = doclineFrame.Document.GetElementsByTagName(doclineFrame.Document, "INPUT")
    local element = nil
	    
    for i = 0, inputCollection.Count - 1, 1 do	
        element = GetElementByCollectionIndex(inputCollection, i)
        if (element ~= nil and element.GetAttribute(element, "name") == "PMID") then
            return element
        end
    end
	
	return nil
end

function IsHomePage(browser)	
	local homeButtonImage = GetElementInFrame("doclinemenu", "navHome")
	
	if (homeButtonImage ~= nil) then
		local src = homeButtonImage.GetAttribute(homeButtonImage, "src")
		
		if (string.find(src, "nav-home-on.gif", 0, true) ~= nil) then
			return true
		end
	end
	
	return false
end

function FindBorrowLink()
	local doclineFrame = GetFrameByName(nil, "doclinemenu")
	if doclineFrame == nil then
		return nil
	end	
	local element = nil
	for i = 0, doclineFrame.Document.All.Count - 1, 1 do
		element = GetElementByWindowIndex(doclineFrame, i)
		if element.InnerHtml == "Borrow" then
			return element
		end
	end
	
	return nil
end

function Finished()
	local importFrame = nil
	local importRegex = nil
	local resultFormPage = false
	if GetForm(nil, "resultForm") ~= nil then
		importFrame = GetFrameByName(nil, "editframe")
		resultFormPage = true
	elseif GetForm(nil, "backForm") ~= nil then
		importFrame = GetFrameByName(nil, "mainframe")
		importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Part Author:(?<Authors>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}Citation:.*?(?<Year>\d{0,4}).*?;((?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n)){0,1})]=]
	else
		importFrame = GetFrameByName(nil, "editframe")
		importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
	end	

	if (importFrame.Document.Body ~= nil) then
		local counter = 0
		while (importFrame.Document.Body.InnerText == "Working on requests, please wait..." and counter < 50) do
			Sleep(100)
			counter = counter + 1
		end
		
		if (counter == 50) then
			return
		end

		if resultFormPage == true then
			if string.find(importFrame.Document.Body.InnerText, "Result:", 0, true) ~= nil then
				importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Title:(?<Title>.*?\n)){0,1}(Author:(?<JournalAuthor>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}(Part Author:(?<Authors>.*?\n)){0,1}Citation:(?<Year>\d{0,4});(?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n))]=]
			else
				importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
			end	
		end
		DoDataImport(importFrame.Document.Body.InnerText, importRegex)
		RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	end
end

function IsFinishedPage(browser)
	if GetForm(nil, "resultForm") ~= nil then
		return true
	elseif GetForm(nil, "backForm") ~= nil then
		return true
	else
		window = GetFrameByName(nil, "editframe")
		
		if window == nil then
			return false
		end
		
		local elementCollection = window.Document.GetElementsByTagName(window.Document, "img")
	
		for i = 0, elementCollection.Count, 1 do	
			element = GetElementByCollectionIndex(elementCollection, i)
			if (element ~= nil and element.GetAttribute(element, "title") == "Full Display") then
				return true
			end
		end
		
		return false		
	end
end

function IsUniqueKeyPage(browser)		
	window = GetFrameByName(nil, "mainframe")
    
    if window == nil then
        return false
    end
    
    local inputCollection = window.Document.GetElementsByTagName(window.Document, "h2")

    for i = 0, inputCollection.Count, 1 do	
        element = GetElementByCollectionIndex(inputCollection, i)
        if (element ~= nil and element.InnerHtml == "Unique Key") then
            return true
        end
    end

    return false
end

RegisterPageHandler("formExists", "user", "LoginLoaded", false)
RegisterPageHandler("custom", "IsHomePage", "OnLoggedIn", false)
RegisterPageHandler("custom", "IsUniqueKeyPage", "SearchFormLoaded", false)
RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)

FieldTranslator = GetFieldTranslator()

Navigate("http://docline.gov/docline/index.cfm")