local routingFormName = 'theform';

function LoginLoaded()
    local browser = GetBrowser();
	browser.ScriptErrorsSuppressed = true;
    
	SetFormValueById("user", "username", FieldTranslator.GetTranslationResults(FieldTranslator, "UserID").Value)
	SetFormValueById("user", "password", FieldTranslator.GetTranslationResults(FieldTranslator, "Password").Value)
	SubmitForm("user")
end

function OnLoggedIn()
	local navRequestsElement = GetElementInFrame("doclinemenu", "navRequests")
	if navRequestsElement ~= nil then
		ClickObjectByReference(GetParentElement(navRequestsElement))
		NavRequestsClicked()
	end
end

function NavRequestsClicked()
	ClickNavItemByInnerHtml("Borrow")
end

function UniqueKeyFormLoaded()
	ClickNavItemByInnerHtml("Loansome Doc Transfer")
end

function OnTransferPageLoaded()
	local reqNumElement = GetElementInFrame("mainframe", "pr")
	
	if reqNumElement == nil then
		return
	end
	
	reqNumElement.SetAttribute(reqNumElement, "value", FieldTranslator.GetTranslationResults(FieldTranslator, "RequestNumber").Value)
	
	local editFrame = GetFrameByName(nil, "mainframe")
	
	if editFrame == nil then
		return
	end
	
	for i = 0, editFrame.Document.All.Count - 1, 1 do
		element = GetElementByWindowIndex(editFrame, i)
		if element.GetAttribute(element, "id") == "_sldt" then
			ClickObjectByReference(element)
			return
		end
	end
end

function RouteFormLoaded()
	-- We will need this later, so I'm going to grab it now so that it will already be cached when I do the SetFormValue calls.	
    local frame = GetFrameByName(nil, "mainframe"); 
	local routeForm = GetForm(frame, routingFormName)
	
	local currentValue;
    
    currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "RequestForm").Value        
	if (currentValue ~= nil) then
        local requestFormElements = routeForm.All:GetElementsByName("REQUEST_FORM");
        
        for i = 0, requestFormElements.Count - 1, 1 do
            input = GetElementByCollectionIndex(requestFormElements, i)
            
            if (input.GetAttribute(input, "value") == currentValue) then
                ClickObjectByReference(input);               
                break;
            end
        end        
	end
    
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "CopyrightCompliance").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "COPYRIGHT_COMPLIANCE", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ServiceLevel").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "SERVICE_LEVEL", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "AuthorizedBy").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "REQUEST_AUTHORIZED_BY", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ReferralReason").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "REFERRAL_REASON", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "MaxCost").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "MAX_COST", currentValue)
	end
		
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PatronName").Value		
	if currentValue ~= nil then
		SetFormValue(routingFormName, "PNAME", currentValue)		    
	end
		
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NetworkShippingOption").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "DELIVERY_NETWORK", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "NLMShippingOption").Value	
	if currentValue ~= nil then		
		SetFormValue(routingFormName, "DELIVERY_NLM", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "PrefixLIBID").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "PREFIX_LIBID", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "ShipToName").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "INST", currentValue)
	end
	currentValue = FieldTranslator.GetTranslationResults(FieldTranslator, "Department").Value
	if currentValue ~= nil then
		SetFormValue(routingFormName, "DEPT", currentValue)
	end
	
	local inputCollection = frame.Document:GetElementsByTagName("input");
	local element = nil;
    
	for i = 0, inputCollection.Count - 1, 1 do
		element = GetElementByCollectionIndex(inputCollection, i)
		if element.GetAttribute(element, "value") == "Finish" then			
            ClickObjectByReference(element)
			HandleManualPageChange()
			return
		end
	end
end

function Finished()
	local importFrame = nil
	local importRegex = nil
	local resultFormPage = false
	if GetForm(nil, "resultForm") ~= nil then
		importFrame = GetFrameByName(nil, "editframe")
		resultFormPage = true
	elseif GetForm(nil, "backForm") ~= nil then
		importFrame = GetFrameByName(nil, "mainframe")
		importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Part Author:(?<Authors>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}Citation:.*?(?<Year>\d{0,4}).*?;((?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n)){0,1})]=]
	else
		importFrame = GetFrameByName(nil, "editframe")
		importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
	end	

	if (importFrame.Document.Body ~= nil) then
		local counter = 0
		while (importFrame.Document.Body.InnerText == "Working on requests, please wait..." and counter < 50) do
			Sleep(100)
			counter = counter + 1
		end
		
		if (counter == 50) then
			return
		end

		if resultFormPage == true then
			if string.find(importFrame.Document.Body.InnerText, "Result:", 0, true) ~= nil then
				importRegex = [=[(?s:Result:(?<ID>\d+).*?\((?<Lender>.*?)\).*?(Title:(?<Title>.*?\n)){0,1}(Author:(?<JournalAuthor>.*?\n)){0,1}(Part Title:(?<Article>.*?\n)){0,1}(Part Author:(?<Authors>.*?\n)){0,1}Citation:(?<Year>\d{0,4});(?<Volume>.*?)\((?<Issue>.*?)\):(?<Pages>.*?\n))]=]
			elseif string.find(importFrame.Document.Body.InnerText, "NLM UNIQUE ID:", 0, true) ~= nil then
				importRegex = [=[(?mxns)
								 .*?(?<ID>\d*?)\swas\srouted\sto
								 .*?\((?<Lender>.+?)\).*?\r\n
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^Title:\s(?<Title>.+?)\r\n)?
								 (^(?!Title:|(Part\s)?Author:).*?\r\n)*
								 (^(Part\s)?Author:\s(?<Authors>.+?)\r\n)?							  
							  ]=]
			else
				importRegex = [=[(?<ID>[0-9]+).+?\((?<Lender>.+?)\).+?\r\n.*?\r\n(?<Authors>.*?)\r\n(?<Article>.*?)\r\n(?<Journal>.*?)\s\d{4}.*?;((?<Volume>.*?)\(((?<Issue>.*?)\):(?<Pages>.*?))|(.*\s?\[Epub ahead of print\]))[\s|.]]=]
			end	
		end
		DoDataImport(importFrame.Document.Body.InnerText, importRegex)
		RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)
	end
end

function ClickNavItemByInnerHtml(html)
	local doclineFrame = GetFrameByName(nil, "doclinemenu")
	if doclineFrame == nil then
		return
	end
	
	for i = 0, doclineFrame.Document.All.Count - 1, 1 do
		element = GetElementByWindowIndex(doclineFrame, i)
		if element.InnerHtml == html then
			ClickObjectByReference(element)
			return
		end
	end
end

function IsHomePage(browser)	
	local homeButtonImage = GetElementInFrame("doclinemenu", "navHome")
	
	if (homeButtonImage ~= nil) then
		local src = homeButtonImage.GetAttribute(homeButtonImage, "src")
		
		if (string.find(src, "nav-home-on.gif", 0, true) ~= nil) then
			return true
		end
	end
	
	return false
end

function IsTransferPage(browser)
	local reqNumElement = GetElementInFrame("mainframe", "pr")
	return reqNumElement ~= nil
end

function IsFinishedPage(browser)
	if GetForm(nil, "resultForm") ~= nil then
		return true
	elseif GetForm(nil, "backForm") ~= nil then
		return true
	else
		window = GetFrameByName(nil, "editframe")
		
		if window == nil then
			return false
		end
		
		local elementCollection = window.Document.GetElementsByTagName(window.Document, "img")
	
		for i = 0, elementCollection.Count, 1 do	
			element = GetElementByCollectionIndex(elementCollection, i)
			if (element ~= nil and element.GetAttribute(element, "title") == "Full Display") then
				return true
			end
		end
		
		return false				
	end
end

function IsUniqueKeyPage(browser)		
	window = GetFrameByName(nil, "mainframe")
    
    if window == nil then
        return false
    end
    
    local inputCollection = window.Document.GetElementsByTagName(window.Document, "h2")

    for i = 0, inputCollection.Count, 1 do	
        element = GetElementByCollectionIndex(inputCollection, i)
        if (element ~= nil and element.InnerHtml == "Unique Key") then
            return true
        end
    end

    return false
end

RegisterPageHandler("formExists", "user", "LoginLoaded", false)
RegisterPageHandler("custom", "IsHomePage", "OnLoggedIn", false)
RegisterPageHandler("custom", "IsUniqueKeyPage", "UniqueKeyFormLoaded", false)
RegisterPageHandler("custom", "IsTransferPage", "OnTransferPageLoaded", false)
RegisterPageHandler("formExists", routingFormName, "RouteFormLoaded", false)
RegisterPageHandler("custom", "IsFinishedPage", "Finished", true)

FieldTranslator = GetFieldTranslator()

Navigate("http://docline.gov/docline/index.cfm")